#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "..\..\usbspi.h"

BYTE bCardImageBuff[0x20000];	//131072bytes.

////////////////////////////////////////////////////////////////////////////
BYTE revbit(BYTE bVal)
{
	bVal = ((bVal & 0x55) << 1) | ((bVal & 0xaa) >> 1);
	bVal = ((bVal & 0x33) << 2) | ((bVal & 0xcc) >> 2);
	return (bVal << 4) | (bVal >> 4);
}

////////////////////////////////////////////////////////////////////////////
BYTE ReadMemory(WORD wAddress)
{
	BYTE i;
	BYTE j;
	BYTE bMask;
	BYTE bExitCode = 0xff;
	BYTE bBuff[16];

	spi_cs(0);

	bBuff[0] = revbit(0x81);				//R}hwb_ 81h
	bBuff[1] = revbit(0x52);				//R}hwb_ 'R'.
	bBuff[2] = revbit(0x00);				//R}hwb_ ǂ.
	bBuff[3] = revbit(0x00);				//R}hwb_ ǂ.
	bBuff[4] = revbit(wAddress >> 8);		//AhXw 8bit.
	bBuff[5] = revbit(wAddress & 0x00ff);	//AhXw 8bit.
	bBuff[6] = revbit(0x00);				//R}h ǂ.
	bBuff[7] = revbit(0x00);				//f[^wb_ ǂ.
	bBuff[8] = revbit(0x00);				//f[^AhX 8bit.
	bBuff[9] = revbit(0x00);				//f[^AhX 8bit.
	spi_rw(10, (BYTE*)&bBuff[0], (BYTE*)&bBuff[0]);

	bMask = revbit(bBuff[8]);
	bMask ^= revbit(bBuff[9]);

	for(i = 0; i < 128; i += 32){
		spi_rw(32, (BYTE*)&bCardImageBuff[(wAddress * 128) + i], (BYTE*)&bCardImageBuff[(wAddress * 128) + i]);

		for(j = 0; j < 32; j++){
			bCardImageBuff[(wAddress * 128) + i + j] = revbit(bCardImageBuff[(wAddress * 128) + i + j]);
			bMask ^= bCardImageBuff[(wAddress * 128) + i + j];
		}
	}

	bBuff[0] = revbit(0x00);	//XORtO.
	bBuff[1] = revbit(0x00);	//ItO.
	spi_rw(2, (BYTE*)&bBuff[0], (BYTE*)&bBuff[0]);

	if((bMask == revbit(bBuff[0])) && (revbit(bBuff[1]) == 'G')){
		bExitCode = 0;
	}

	spi_cs(1);

	return bExitCode;
}

////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	int i;
	int iOutFileHandle;
	WORD wAddress;

	if(argc < 2){
		printf("usage : psmr filename\n");
		return -1;
	}

	Init();

	spi_cs(1);
	spi_mode(3);
	spi_speed(47);		//250kHz.
	spi_ack(SPIADP_ACK_RISING_EDGE);

	memset((void*)&bCardImageBuff[0], 0x00, 0x20000);

	for(wAddress = 0; wAddress < 1024; wAddress++){
		printf("%4d/1024\r", wAddress + 1);
		if(ReadMemory(wAddress) != 0){
			printf("\nRead error.\n");
			break;
		}
	}
	putchar('\n');

	iOutFileHandle = open(argv[1],_O_BINARY | _O_WRONLY | _O_CREAT | _O_TRUNC, _S_IWRITE);
	if(iOutFileHandle == -1){
		printf("File Open Error\n");
		return -1;
	}

	write(iOutFileHandle, bCardImageBuff, 0x20000);

	close(iOutFileHandle);

	return 0;
}
