#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "..\..\usbspi.h"

BYTE bCardImageBuff[0x20000];	//131072bytes.

////////////////////////////////////////////////////////////////////////////
BYTE revbit(BYTE bVal)
{
	bVal = ((bVal & 0x55) << 1) | ((bVal & 0xaa) >> 1);
	bVal = ((bVal & 0x33) << 2) | ((bVal & 0xcc) >> 2);
	return (bVal << 4) | (bVal >> 4);
}

////////////////////////////////////////////////////////////////////////////
BYTE WriteMemory(WORD wAddress)
{
	BYTE i;
	BYTE j;
	BYTE bMask;
	BYTE bExitCode = 0xff;
	BYTE bBuff[8];

	spi_cs(0);

	bBuff[0] = revbit(0x81);				//R}hwb_ 81h
	bBuff[1] = revbit(0x57);				//R}hwb_ 'W'.
	bBuff[2] = revbit(0x00);				//R}hwb_ ǂ.
	bBuff[3] = revbit(0x00);				//R}hwb_ ǂ.
	bBuff[4] = revbit(wAddress >> 8);		//AhXw 8bit.
	bBuff[5] = revbit(wAddress & 0x00ff);	//AhXw 8bit.
	spi_rw(6, (BYTE*)&bBuff[0], (BYTE*)&bBuff[0]);

	bMask = (BYTE)(wAddress >> 8);
	bMask ^= (BYTE)(wAddress & 0x00ff);

	for(i = 0; i < 128; i += 32){
		for(j = 0; j < 32; j++){
			bMask ^= bCardImageBuff[(wAddress * 128) + i + j];
			bCardImageBuff[(wAddress * 128) + i + j] = revbit(bCardImageBuff[(wAddress * 128) + i + j]);
		}

		spi_rw(32, (BYTE*)&bCardImageBuff[(wAddress * 128) + i], (BYTE*)&bCardImageBuff[(wAddress * 128) + i]);
	}

	bBuff[0] = revbit(bMask);	//XORtO.
	bBuff[1] = revbit(0x00);	//IXe[^X ǂ.
	bBuff[2] = revbit(0x00);	//IXe[^X ǂ.
	bBuff[3] = revbit(0x00);	//ItO.
	spi_rw(4, (BYTE*)&bBuff[0], (BYTE*)&bBuff[0]);

	if(revbit(bBuff[3]) == 'G'){
		bExitCode = 0;
	}

	spi_cs(1);

	return bExitCode;
}

////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	int i;
	int iInFileHandle;
	WORD wAddress;

	if(argc < 2){
		printf("usage : psmw filename\n");
		return -1;
	}

	iInFileHandle = open(argv[1],_O_BINARY | _O_RDONLY, _S_IREAD);
	if(iInFileHandle == -1){
		printf("File Open Error\n");
		return -1;
	}

	if(read(iInFileHandle, (void*)&bCardImageBuff, 0x20000) != 0x20000){
		printf("File Read Error\n");
		close(iInFileHandle);
		return -1;
	}

	close(iInFileHandle);

	Init();

	spi_cs(1);
	spi_mode(3);
	spi_speed(47);		//250kHz.
	spi_ack(SPIADP_ACK_RISING_EDGE);

	for(wAddress = 0; wAddress < 1024; wAddress++){
		printf("%4d/1024\r", wAddress + 1);
		if(WriteMemory(wAddress) != 0){
			printf("\nWrite error.\n");
			break;
		}
	}
	putchar('\n');

	return 0;
}
