#include <stdio.h>
#include <windows.h>
#include "..\..\usbspi.h"

#define W2DW(a, b)				((DWORD)(a) | ((DWORD)(b) << 8))
#define DW2DW(a, b, c, d)		((DWORD)(a) | ((DWORD)(b) << 8) | ((DWORD)(c) << 16) | ((DWORD)(d) << 24))

typedef union tagADDR_CNV{
	DWORD dwaddr;
	struct tagBADDR{
		BYTE a1;
		BYTE a2;
		BYTE a3;
		BYTE a4;
	} BADDR;
} ADDR_CNV;
ADDR_CNV addr_cnv;

BYTE bSDCardBuffer[512];

#define CARD_VER_E	0
#define CARD_VER_1	1
#define CARD_VER_2	2
BYTE bCardVersion = CARD_VER_E;

#define CARD_ADDR_MODE_BYTE		0
#define CARD_ADDR_MODE_BLOCK	1
BYTE bCardAddressMode = CARD_ADDR_MODE_BYTE;

////////////////////////////////////////////////////////////////////////////
// J[h̃X|XM.
//
// IN:
//
// OUT:
//
// RETURN:
//  J[h̃X|X.
//
////////////////////////////////////////////////////////////////////////////
BYTE MMGetResponse(VOID)
{
	BYTE i;
	BYTE ret;

	for(i = 0; i < 10; i++){
		ret = spi_rw_single(0xff);

		if(!(ret & 0x80)){
			break;
		}
	}

	return ret;
}

////////////////////////////////////////////////////////////////////////////
static BYTE MMSendCmd(BYTE bCmd, BYTE bArg1, BYTE bArg2, BYTE bArg3, BYTE bArg4, BYTE bCRC)
{
	BYTE ret;
	BYTE bSPIBuff[8];

	if(bCmd & 0x80){
		bCmd &= 0x7F;
		MMSendCmd(0x40 + 55, 0, 0, 0, 0, 0x01);
		ret = MMGetResponse();
		if(ret > 1){
			return ret;
		}
	}

	spi_cs(1);
	spi_rw_single(0xff);
	spi_cs(0);
	spi_rw_single(0xff);

	bSPIBuff[0] = bCmd;
	bSPIBuff[1] = bArg1;
	bSPIBuff[2] = bArg2;
	bSPIBuff[3] = bArg3;
	bSPIBuff[4] = bArg4;
	bSPIBuff[5] = bCRC;
	spi_rw(6, (BYTE*)&bSPIBuff[0], (BYTE*)&bSPIBuff[0]);

	return 0xff;
}

////////////////////////////////////////////////////////////////////////////
// J[h512oCgǂݍ.
//
// ǂݍ񂾃f[^SRAM̃AhX0Ɋi[.
//
// IN:
//   address ǂݍ݂AhX.
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
BYTE MMReadData(DWORD address)
{
	WORD i;
	BYTE rc;

	spi_cs(0);

	if(bCardAddressMode == CARD_ADDR_MODE_BYTE){
		addr_cnv.dwaddr = address << 9;
	}
	else{
		addr_cnv.dwaddr = address;
	}
	MMSendCmd(0x40 + 17, addr_cnv.BADDR.a4, addr_cnv.BADDR.a3, addr_cnv.BADDR.a2, addr_cnv.BADDR.a1, 0x01);

	rc = 0;
	if(MMGetResponse() == 0){
		for(i = 0; i < 10; i++){
			if(spi_rw_single(0xff) == 0xfe){
				rc = 1;
				break;
			}
		}
	}

	if(rc == 1){
		for(i = 0; i < 512; i += 32){
			memset((void*)&bSDCardBuffer[i], 0xff, 32);
			spi_rw(32, (BYTE*)&bSDCardBuffer[i], (BYTE*)&bSDCardBuffer[i]);
		}

		//CRC2oCgǂ.
		spi_rw_single(0xff);
		spi_rw_single(0xff);

		for(i = 0; i < 2048; i++){
			if(spi_rw_single(0xff) == 0xff)
				break;
		}
	}

	spi_cs(1);

	return rc;
}

////////////////////////////////////////////////////////////////////////////
// J[h̏.
//
// dONSPI[hւ̈ڍs葱.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
BYTE MMReset(VOID)
{
	BYTE ret;
	WORD wi;
	BYTE ocr[4];

	spi_cs(1);

	//_~[80NbN.
	for(wi = 0; wi < 10; wi++){
		spi_rw_single(0xff);
	}

	spi_cs(0);

	MMSendCmd(0x40, 0, 0, 0, 0, 0x95);
	ret = MMGetResponse();
	if(ret == 1){
		MMSendCmd(0x40 + 8, 0, 0, 0x01, 0xaa, 0x87);
		ret = MMGetResponse();
		if(ret == 1){
			ocr[0] = spi_rw_single(0xff);
			ocr[1] = spi_rw_single(0xff);
			ocr[2] = spi_rw_single(0xff);
			ocr[3] = spi_rw_single(0xff);

			if(ocr[2] == 0x01 && ocr[3] == 0xaa){
				for(wi = 0; wi < 70; wi++){		//1b(15ms x 70).
					MMSendCmd(0xc0 + 41, 0x40, 0, 0, 0, 0x01);
					ret = MMGetResponse();
					if(ret == 0x00){
						break;
					}
				}

				MMSendCmd(0x40 + 58, 0, 0, 0, 0, 0x01);
				ret = MMGetResponse();
				if(ret == 0x00){
					ocr[0] = spi_rw_single(0xff);
					ocr[1] = spi_rw_single(0xff);
					ocr[2] = spi_rw_single(0xff);
					ocr[3] = spi_rw_single(0xff);

					if((ocr[0] & 0x40) != 0){
						bCardAddressMode = CARD_ADDR_MODE_BLOCK;
					}
					else{
						bCardAddressMode = CARD_ADDR_MODE_BYTE;
					}
					bCardVersion = CARD_VER_2;
				}
			}
			else{
			}
		}
		else{
			for(wi = 0; wi < 70; wi++){		//1b(15ms x 70).
				MMSendCmd(0x40 + 1, 0, 0, 0, 0, 0x01);
				ret = MMGetResponse();
				if(ret == 0x00){
					break;
				}
			}

			MMSendCmd(0x40 + 16, 0, 0, 0x02, 0x00, 0x01);
			ret = MMGetResponse();
			if(ret == 0){
				bCardVersion = CARD_VER_1;
				bCardAddressMode = CARD_ADDR_MODE_BYTE;
			}
		}
	}
	else{
	}

	spi_cs(1);

	spi_rw_single(0xff);

	return ret;
}

////////////////////////////////////////////////////////////////////////////
void memdump(DWORD dwAddr)
{
	WORD i, j;

	for(i = 0; i < 512; i += 16){
		printf("%08X ", dwAddr + i);

		for(j = 0; j < 16; j++){
			printf("%02X ", bSDCardBuffer[i + j]);
		}

		for(j = 0; j < 16; j++){
			if(isprint(bSDCardBuffer[i + j]) != 0){
				printf("%c", bSDCardBuffer[i + j]);
			}
			else{
				printf(".");
			}
		}
		printf("\n");
	}

}

////////////////////////////////////////////////////////////////////////////
int main(int argc, char **argv)
{
	DWORD dwStartSect = 0;
	DWORD dwReadSect = 1;
	DWORD dwNum;
	int i;

	for(i = 1; i < argc; i++){
		if(strlen(argv[i]) >= 3){
			if(argv[i][0] == '-'){
				switch(argv[i][1]){
				case 's':
				case 'S':
					dwStartSect = atoi((char*)&argv[i][2]);
					break;
				case 'n':
				case 'N':
					dwReadSect = atoi((char*)&argv[i][2]);
					break;
				}
			}

		}
	}

	if(dwReadSect == 0){
		dwReadSect = 1;
	}

	Init();

	spi_mode(0);		//SD/MMC̓[h0

	//SD/MMC̏100kHz`400kHzɐݒ肷.
	spi_speed(119);		//Fosc/480    100,000Hz

	MMReset();
	if(bCardVersion == CARD_VER_E){
		printf("MMC/SD not exist\n");
		return -1;
	}
	else{
		printf("%s exist (%s Address)\n",
			bCardVersion == CARD_VER_1 ? "SDSC" : "SDHC or SDXC",
			bCardAddressMode == CARD_ADDR_MODE_BYTE ? "Byte" : "Block"
			);
	}

	//SD/MMC̏̐ݒ.
	spi_speed(  0);		//Fosc/4   12,000,000Hz
	//spi_speed(  1);		//Fosc/8    6,000,000Hz
	//spi_speed(  2);		//Fosc/12   4,000,000Hz
	//spi_speed(  3);		//Fosc/16   3,000,000Hz
	//spi_speed(  4);		//Fosc/20   2,400,000Hz
	//spi_speed(  5);		//Fosc/24   2,000,000Hz
	//spi_speed(  7);		//Fosc/32   1,500,000Hz
	//spi_speed(  9);		//Fosc/40   1,200,000Hz
	//spi_speed( 11);		//Fosc/48   1,000,000Hz
	//spi_speed( 14);		//Fosc/60     800,000Hz
	//spi_speed( 15);		//Fosc/64     750,000Hz
	//spi_speed( 19);		//Fosc/80     600,000Hz
	//spi_speed( 23);		//Fosc/96     500,000Hz
	//spi_speed( 29);		//Fosc/120    400,000Hz
	//spi_speed( 39);		//Fosc/160    300,000Hz
	//spi_speed( 59);		//Fosc/240    200,000Hz
	//spi_speed(119);		//Fosc/480    100,000Hz

	for(dwNum = 0; dwNum < dwReadSect; dwNum++){
		MMReadData(dwStartSect + dwNum);
		memdump((dwStartSect + dwNum) << 9);
	}

	return 0;
}
